
function RemoteQueue(){
	var _self = this;
	
	this.queue = Array();
	this.active = false;
	this.maximumConnections = 3;
	this.activeConnections = 0;
	
	this.timer = null;
	this.timerAction = function(){ _self.animateIcon(); };
	this.animatePosition = 0;
	
	this.queueActive = false;
	this.subEpgActive = false;
	this.subPopularActive = false;
	this.subMguActive = false;
	this.subMgsActive = false;
	this.subRecommendedActive = false;
	this.subUpdateCheckerActive = false;
	this.subFavoritesActive = false;
	this.subDevicesActive = false;
	this.subKeywordsActive = false;
}

RemoteQueue.prototype.isSubsActive = function(){
	if(this.subDevicesActive || this.subEpgActive || this.subPopularActive || this.subMguActive || this.subMgsActive || this.subRecommendedActive || this.subUpdateCheckerActive || this.subFavoritesActive || this.subKeywordsActive){
//        DEBUGLOG("RemoteQueue.js[28]: isSubsActive: DEV: " + this.subDevicesActive + "  EPG: " + this.subEpgActive + "  POP: " + this.subPopularActive + "  MGU: " + this.subMguActive + "  MGS: " + this.subMgsActive + "  REC: " + this.subRecommendedActive + "  UPD: " + this.subUpdateCheckerActive + "  FAV: " + this.subFavoritesActive + "  KEY: " + this.subKeywordsActive + " : TRUE");
		return true;
    }

//    DEBUGLOG("RemoteQueue.js[32]: isSubsActive: FALSE");
	return false;
}

RemoteQueue.prototype.setSubActive = function(sub){
//    DEBUGLOG("RemoteQueue.js[33]: setSubActive: " + sub);
	if(sub == kEpgFeed)
		this.subEpgActive = true;
	else if(sub == kPopularFeed)
		this.subPopularActive = true;
	else if(sub == kMGUFeed)
		this.subMguActive = true;
	else if(sub == kMGSFeed)
		this.subMgsActive = true;
	else if(sub == kRecommendedFeed )
		this.subRecommendedActive = true;
	else if(sub == kUpdateCheckerFeed)
		this.subUpdateCheckerActive = true;
	else if(sub == kFavoritesFeed)
		this.subFavoritesActive = true;
	else if(sub == kDevicesFeed)
		this.subDevicesActive = true;
	else if(sub == kKeywordsFeed)
		this.subKeywordsActive = true;

	if(this.isSubsActive() && !this.active){
		this.active = true;
		document.getElementById("network_activity").style.display = "block";
		this.animatePosition = 0;
		if(this.timer == null)
			this.timer = setInterval(this.timerAction, 40);
	}
}

RemoteQueue.prototype.setSubInactive = function(sub){
//    DEBUGLOG("RemoteQueue.js[33]: setSubInactive: " + sub);
	if(sub == kEpgFeed)
		this.subEpgActive = false;
	else if(sub == kPopularFeed)
		this.subPopularActive = false;
	else if(sub == kMGUFeed)
		this.subMguActive = false;
	else if(sub == kMGSFeed)
		this.subMgsActive = false;
	else if(sub == kRecommendedFeed)
		this.subRecommendedActive = false;
	else if(sub == kUpdateCheckerFeed)
		this.subUpdateCheckerActive = false;
	else if(sub == kFavoritesFeed)
		this.subFavoritesActive = false;
	else if(sub == kDevicesFeed)
		this.subDevicesActive = false;
	else if(sub == kKeywordsFeed)
		this.subKeywordsActive = false;

	if(!this.isSubsActive() && !this.queueActive){
//		if(this.active)
//			DEBUGLOG("deactivating");
		clearInterval(this.timer)
		this.timer = null;
		document.getElementById("network_activity").style.display = "none";
		this.active = false;
	}
}

RemoteQueue.prototype.animateIcon = function(){
	document.getElementById("network_activity").style.backgroundPosition = "0px -" + (this.animatePosition * 15) + "px";
	if(this.animatePosition == 17){
		this.animatePosition = 0;
		return;
	}

	this.animatePosition++;
}

RemoteQueue.prototype.addToQueue = function(address, callback){
	var _self = this;
	var downloader = new RemoteQueueDownloader(address, function(dl){ _self.callback(dl); });
	var item = {downloader:downloader, callback:callback};
	this.queue.push(item)
	if(this.queueActive == false){
		this.start();
	} else {
		if(this.activeConnections < this.maximumConnections)
			downloader.run();
	}
}

RemoteQueue.prototype.start = function(){
	this.queueActive = true;
	this.active = true;
	this.animatePosition = 0;
	if(this.timer == null)
		this.timer = setInterval(this.timerAction, 40);
	document.getElementById("network_activity").style.display = "block";
	for(x=0;x<this.queue.length;x++){
		if(this.activeConnections < this.maximumConnections){
			this.queue[x].downloader.run();
			this.activeConnections++;
		}
	}
}

RemoteQueue.prototype.doNext = function(){
//	DEBUGLOG("doNext()");
	for(x=0;x<this.queue.length;x++){
		if(this.activeConnections < this.maximumConnections && this.queue[x].downloader.active == false){
//			DEBUGLOG(x);
			this.queue[x].downloader.run();
			this.activeConnections++;
		}
	}
}

RemoteQueue.prototype.callback = function(dld){
//	DEBUGLOG("callback = " + dld)
//	DEBUGLOG(dld.connection.responseText);
	for(x=0;x<this.queue.length;x++){
		if(this.queue[x].downloader == dld){
//			DEBUGLOG("found");
			this.queue[x].callback(dld.connection.responseText);
			this.queue.splice(x, 1);
			this.activeConnections--;
			if(this.activeConnections == 0)
				this.queueActive = false;
			break;
		}
//		DEBUGLOG("not found");
	}
	if(this.queue.length == 0){
//		DEBUGLOG("RemoteQueue.js[156]: queue empty")
		this.queueActive = false;
		if(!this.isSubsActive()){
			this.active = false;
			clearInterval(this.timer);
			this.timer = null
			document.getElementById("network_activity").style.display = "none";
		}
	} else {
//		DEBUGLOG("RemoteQueue.js[165]: queue: " + this.queue.length);
		this.doNext();
	}
}

function RemoteQueueDownloader(address, callback){
	this.connection = new XMLHttpRequest();
	this.address = address;
	this.callback = callback;
	this.active = false;
}

RemoteQueueDownloader.prototype.run = function(){
	var _self = this;
	this.active = true;
	this.connection.onreadystatechange = function(){ _self.stateChange(); };
	this.connection.open( "GET", encodeURI(this.address), true);
	this.connection.send();
}

RemoteQueueDownloader.prototype.stateChange = function(){
	if(this.connection.readyState == 4){
		var _self = this;
		rmtQueue.callback(this);
	}
}
