function Favorites(){
	this.contentArray = new Array();
	this.dlHeader = new Object();
}

Favorites.prototype.downloaderCallback = function(json){
	this.parseData(json);
	favoriteRecordDataUpdated();
}

Favorites.prototype.clear = function(){
	this.contentArray.length = 0;
}

Favorites.prototype.parseData = function(json){
	/**
	 * Put response into a temp array in case it fails
	 */
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	/**
	 * Copy & split temp array into Header & Data
	 */
	this.dlHeader = tempArray.shift();
    DEBUGLOG("favorites.js[27]: return_code: " + this.dlHeader["return_code"]);
    if(this.dlHeader['return_code'] == "10") {
        ath.expire();
        return;
    } else if(this.dlHeader['return_code'] == "55") {
        ath.subExpired();
        return;
    }
	this.contentArray.length = 0;
	this.contentArray = this.contentArray.concat(tempArray);
	
	/**
	 * Record "last_fetch" to use in limiting "auto hits"
	 */
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
}

Favorites.prototype.recordIndexForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++) {
		if(this.contentArray[i]['series_id'] == seriesID)
			return i;
    }
	
	return -1;
}

Favorites.prototype.recordForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++) {
		if(this.contentArray[i]['series_id'] == seriesID)
			return this.contentArray[i];
    }
	
	return null;
}


Favorites.prototype.updateData = function(userInitiated){
	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
		return;
	}
	
	favDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kFavoritesFeed);
	favDownloader.fetchURL();
}	
