function Popular(){
	this.isSelected = false;
	this.contentHeight = 0;
	this.height = parseInt(loadPref("popularScrollPoint"), 10);	

	this.contentArray = new Array();

	this.resizeorigin = 0;
	resizestart = 0;
	this.dlHeader = {};
}

Popular.prototype.clear = function(){
	while(document.getElementById("popular_content_inner_container").hasChildNodes())
		document.getElementById("popular_content_inner_container").removeChild(document.getElementById("popular_content_inner_container").firstChild);
		
	this.contentArray.length = 0;
	this.contentHeight = 0;
	this.isSelected = false;
}


Popular.prototype.setup = function(){
	var _self = this;
	document.getElementById("popular_resize_control").onmousedown = function(event){ _self.beginresize((event)); }
	document.getElementById("popular_resize_control").ondblclick = function(event){ _self.resetHeight(); }
}

Popular.prototype.hide = function(){
	document.getElementById("popular_container").style.display = "none";
}

Popular.prototype.show = function(){
	document.getElementById("popular_container").style.display = "block";
}

Popular.prototype.animationHeight = function(){
	var height = 0;
	if(this.height == 0)
		height = this.contentHeight + 4;
	else
		height = this.height;
	if(height < 74)
		return 74;
	return height - 5;
}

Popular.prototype.sectionHeight = function(){
	var height = 0;
	if(this.height == 0)
		height = this.contentHeight + 4;
	else
		height = this.height;
	if(height < 74)
		return 74;
	if(height > screen.availHeight - 50)
		return screen.availHeight - 50
	return height;
}

Popular.prototype.buildDisplay = function(){
}

Popular.prototype.updateDisplay = function(){
	while(popular_content_inner_container.firstChild != null)
		popular_content_inner_container.removeChild(popular_content_inner_container.firstChild);
	
	for(x=0;x<this.contentArray.length;x++){
		var seriesRecord    = mgs.recordForID(this.contentArray[x]['series_id']);
		var favRecord       = fav.recordForID(this.contentArray[x]['series_id']);
		var rcmRecord       = rcm.recordForID(this.contentArray[x]['series_id']);
		
		var container = document.createElement("div");
		container.style.position = "absolute";
		container.style.top = (x * 13) + "px";
		container.style.height = "13px";
		container.style.width = "355px";
		container.style.overflow = "hidden"
		document.getElementById("popular_content_inner_container").appendChild(container);
	
		var barContainer = document.createElement("div");
		barContainer.style.background = "url(images/lists/list_popular.png)"
		barContainer.style.position = "absolute";
		barContainer.style.top = "2px";
		barContainer.style.left = "10px";
		barContainer.style.height = "9px";
		barContainer.style.width = "50px";
		container.appendChild(barContainer);
	
		var bar = document.createElement("img");
		bar.src = "images/lists/list_popularbar.png"
		bar.style.height = "9px";
		bar.style.width = this.contentArray[x]["bar_filled_width_2"] + "px";
		barContainer.appendChild(bar);

		var iconSize = 0;
		
		if(seriesRecord || favRecord || rcmRecord ){
			/**
			 * Check if the program is part of a series recording or just a single recording.
			 */
			if(seriesRecord){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.style.position = "absolute";
				container.appendChild(statusImage);
				statusImage.style.left = "68px";
				statusImage.style.top = "2px";
				iconSize += 18
			}
			if(favRecord){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_favourite.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.style.position = "absolute";
				statusImage.style.left = (68 + iconSize) + "px";
				statusImage.style.top = "2px";
				container.appendChild(statusImage);
				iconSize += 18
			}
			if(rcmRecord && !seriesRecord && !favRecord ){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recommended.png";
				statusImage.width = 8;
				statusImage.height = 12;
				statusImage.style.position = "absolute";
				statusImage.style.left = (68 + iconSize) + "px";
				statusImage.style.top = "2px";
				container.appendChild(statusImage);
				iconSize += 12
			}
		}
		
		if(iconSize != 0)
			iconSize += 1;
	
		var show = document.createElement("div");
		show.innerHTML = this.contentArray[x]["series_name"];
		show.style.font = "bold 10px Lucida Grande"
		show.style.left = (68 + iconSize) + "px";
		show.style.width = (285 - iconSize) + "px";
		show.style.color = "#ffffff";
		show.style.position = "absolute";
		container.appendChild(show);
		show.setAttribute("onclick", "sht.fillEpgSheetDetails('" + this.contentArray[x]["series_id"] +"', 2, false, false)");
	}
	
	this.contentHeight = x * 13;
}

Popular.prototype.resize = function(){
	var height = this.sectionHeight();
	
	document.getElementById("popular_container").style.height = (height - 3) + "px";
	document.getElementById("popular_content_inner_container").style.height = (this.contentHeight) + "px"
	document.getElementById("popular_content_container").style.height = (height - 3) + "px";
	document.getElementById("popular_resize_control").style.top = (height - 16) + "px";
	document.getElementById("popular_scroller").style.height = (height - 16) + "px";
	
	if(this.isSelected){
		resizeFront(72 + (height - 2) + 35)
		document.getElementById("main_container").style.height = (height - 5) + "px";
		document.getElementById("main_base").style.top = (72 + (height - 5)) + "px";
	}
	popularScrollArea.refresh();
	popularScroller.refresh();
}



function doresizePopular(event){
  	popular.doresize(event);
}

function endresizePopular(event) {
  	popular.endresize();
}


Popular.prototype.beginresize = function(event){
	var _self = this;
	this.resizeorigin = event.y;
	this.resizestart = this.sectionHeight();
	document.addEventListener("mousemove",doresizePopular, false);
	document.addEventListener("mouseup", endresizePopular, false);
}

Popular.prototype.doresize = function(event){
	newheight =  event.y - this.resizeorigin;
	this.height = this.resizestart + newheight;
	if(this.height < 74)
		this.height = 74;

	if((this.height - 4) > this.contentHeight)
		this.height = this.contentHeight + 4;

	this.resize();
}

Popular.prototype.endresize = function(){
	document.removeEventListener("mousemove",doresizePopular, false);
	document.removeEventListener("mouseup", endresizePopular, false);
	savePref(this.height, "popularScrollPoint");
}

Popular.prototype.resetHeight = function(){
	this.height = 0;
	savePref("0", "popularScrollPoint");
	this.isSelected = false;
	oldHeight = parseInt(document.getElementById("popular_container").style.height, 10);
	this.resize();
	this.isSelected = true;
	resizeFromHeightReset(oldHeight, document.getElementById("popular_container"));
}


Popular.prototype.downloaderCallback = function(json){
	this.parseData(json);
	this.updateDisplay();
	this.resize();
}

Popular.prototype.parseData = function(json){
	var currentDate = new Date();
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
	/**
	 * Put response into a temp array in case it fails
	 */
	var tempArray = eval(json);
	if(!tempArray)
		return;
		
	/**
	 * Copy & split temp array into Header & Data
	 */
	this.dlHeader = tempArray.shift();
    DEBUGLOG("popular.js[263]: return_code: " + this.dlHeader["return_code"]);
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000, 10);
    if(this.dlHeader['return_code'] == "10") {
        ath.expire();
        return;
    } else if(this.dlHeader['return_code'] == "55") {
        ath.subExpired();
        return;
    }
	this.contentArray.length = 0;
	this.contentArray = this.contentArray.concat(tempArray);
}

Popular.prototype.updateData = function(userInitiated){
	//DEBUGLOG("data.js[568]: Popular.updateData(" + userInitiated + ")");

	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 15) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference))
	{
	//	DEBUGLOG("data.js[578]: Auto fetch and last fetch within minimum hit time.");
		return;
	}
	
	popularDownloader.buildURL(0, userInitiated);
	rmtQueue.setSubActive(kPopularFeed);
	popularDownloader.fetchURL();
}	
	
Popular.prototype.recordForID = function(seriesID){
	var popularArrayLength = this.contentArray.length;
	for(var i=0;i<popularArrayLength;i++)
		if(this.contentArray[i]['series_id'] == seriesID)
			return this.contentArray[i];
	
	return null;
}